ompi/mca/btl/mvapi/btl_mvapi.h File Reference.TH "ompi/mca/btl/mvapi/btl_mvapi.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/btl/mvapi/btl_mvapi.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include <sys/types.h>\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/btl/btl.h'\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'mca/mpool/mpool.h'\fP
.br
\fC#include 'mca/btl/base/btl_base_error.h'\fP
.br
\fC#include 'mca/btl/base/base.h'\fP
.br
\fC#include 'btl_mvapi_endpoint.h'\fP
.br
\fC#include <vapi.h>\fP
.br
\fC#include <mtl_common.h>\fP
.br
\fC#include <vapi_common.h>\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_BTL_IB_LEAVE_PINNED\fP   1"
.br
.ti -1c
.RI "#define \fBMCA_BTL_MVAPI_POST_SRR_HIGH\fP(mvapi_btl, additional)"
.br
.ti -1c
.RI "#define \fBMCA_BTL_MVAPI_POST_SRR_LOW\fP(mvapi_btl, additional)"
.br
.ti -1c
.RI "#define \fBMCA_BTL_MVAPI_POST_SRR_SUB\fP(cnt, mvapi_btl, frag_list, srd_posted, nic, srq_hndl)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_btl_mvapi_component_t\fP \fBmca_btl_mvapi_component_t\fP"
.br
.ti -1c
.RI "typedef mca_btl_base_recv_reg_t \fBmca_btl_mvapi_recv_reg_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_mvapi_module_t\fP \fBmca_btl_mvapi_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_btl_mvapi_component_open\fP (void)"
.br
.RI "\fIRegister IB component parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_btl_base_module_t\fP ** \fBmca_btl_mvapi_component_init\fP (int *num_btl_modules, bool allow_multi_user_threads, bool have_hidden_threads)"
.br
.RI "\fIIB component initialization. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_component_progress\fP (void)"
.br
.RI "\fIIB component progress. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_register\fP (struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_finalize\fP (struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fICleanup any resources held by the BTL. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_add_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_del_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_send\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.br
.RI "\fIPML->BTL Initiate a send of the specified size. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_put\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *decriptor)"
.br
.RI "\fIPML->BTL Initiate a put of the specified size. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_get\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *decriptor)"
.br
.RI "\fIPML->BTL Initiate a get of the specified size. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_mvapi_alloc\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.br
.RI "\fIAllocate a descriptor. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_free\fP (struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.RI "\fIReturn a segment allocated by this BTL. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_mvapi_prepare_src\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *peer, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPack data and return a descriptor that can be used for send/put. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_mvapi_prepare_dst\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *peer, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIAllocate a descriptor initialized for RDMA write. \fP"
.ti -1c
.RI "void \fBmca_btl_mvapi_send_frag_return\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_mvapi_frag_t\fP *)"
.br
.RI "\fIReturn a send fragment to the modules free list. \fP"
.ti -1c
.RI "int \fBmca_btl_mvapi_module_init\fP (\fBmca_btl_mvapi_module_t\fP *mvapi_btl)"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBmca_btl_mvapi_component_t\fP \fBmca_btl_mvapi_component\fP"
.br
.ti -1c
.RI "\fBmca_btl_mvapi_module_t\fP \fBmca_btl_mvapi_module\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_BTL_MVAPI_POST_SRR_HIGH(mvapi_btl, additional)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    do { \
        OPAL_THREAD_LOCK(&mvapi_btl->ib_lock); \
        if(mvapi_btl->srd_posted_hp <= mvapi_btl->rd_low+additional && \
           mvapi_btl->srd_posted_hp < mvapi_btl->rd_num){ \
           MCA_BTL_MVAPI_POST_SRR_SUB(mvapi_btl->rd_num -  \
                                      mvapi_btl->srd_posted_hp, \
                                      mvapi_btl, \
                                      &mvapi_btl->recv_free_eager, \
                                      &mvapi_btl->srd_posted_hp, \
                                      mvapi_btl->nic, \
                                      mvapi_btl->srq_hndl_hp); \
        } \
        OPAL_THREAD_UNLOCK(&mvapi_btl->ib_lock); \
    }while(0);\
}
.fi
.SS "#define MCA_BTL_MVAPI_POST_SRR_LOW(mvapi_btl, additional)"
.PP
\fBValue:\fP
.PP
.nf
{ \
  do { \
    OPAL_THREAD_LOCK(&mvapi_btl->ib_lock); \
    if(mvapi_btl->srd_posted_lp <= mvapi_btl->rd_low+additional && \
       mvapi_btl->srd_posted_lp < mvapi_btl->rd_num){ \
        MCA_BTL_MVAPI_POST_SRR_SUB(mvapi_btl->rd_num -  \
                                            mvapi_btl->srd_posted_lp, \
                                            mvapi_btl, \
                                            &mvapi_btl->recv_free_max, \
                                            &mvapi_btl->srd_posted_lp, \
                                            mvapi_btl->nic, \
                                            mvapi_btl->srq_hndl_lp); \
    } \
    OPAL_THREAD_UNLOCK(&mvapi_btl->ib_lock); \
  } while(0); \
}
.fi
.SH "Function Documentation"
.PP 
.SS "int mca_btl_mvapi_add_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers, ompi_bitmap_t * reachable)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeers\fP (OUT) Set of (optional) peer addressing info. 
.br
\fIpeers\fP (IN/OUT) Set of processes that are reachable via this BTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_mvapi_alloc (struct \fBmca_btl_base_module_t\fP * btl, size_t size)"
.PP
Allocate a descriptor. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsize\fP (IN) Request segment size.
.RE
.PP
When allocating a segment we pull a pre-alllocated segment from one of two free lists, an eager list and a max list 
.SS "\fBmca_btl_base_module_t\fP** mca_btl_mvapi_component_init (int * num_btl_modules, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
IB component initialization. 
.PP
We must loop through all the hca id's, get there handles and for each hca we query the number of ports on the hca and set up a distinct btl module for each hca port 
.SS "int mca_btl_mvapi_del_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fInproc\fP (IN) Number of processes. 
.br
\fIprocs\fP (IN) Set of processes. 
.br
\fIpeers\fP (IN) Set of peer data structures. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_btl_mvapi_finalize (struct \fBmca_btl_base_module_t\fP * btl)"
.PP
Cleanup any resources held by the BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP BTL instance. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "int mca_btl_mvapi_free (struct \fBmca_btl_base_module_t\fP * btl, \fBmca_btl_base_descriptor_t\fP * des)"
.PP
Return a segment allocated by this BTL. 
.PP
Return the segment to the appropriate preallocated segment list 
.SS "int mca_btl_mvapi_get (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * btl_peer, struct \fBmca_btl_base_descriptor_t\fP * decriptor)"
.PP
PML->BTL Initiate a get of the specified size. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIbtl_base_peer\fP (IN) BTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (allocated by PML via mca_btl_base_request_alloc_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting BTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the BTL was able to queue one or more fragments 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_mvapi_prepare_dst (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Allocate a descriptor initialized for RDMA write. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIpeer\fP (IN) BTL peer addressing prepare dest's behavior depends on the following: Has a valid memory registration been passed to prepare_src? if so we attempt to use the pre-registred user-buffer, if the memory registration is to small (only a portion of the user buffer) then we must reregister the user buffer Has the user requested the memory to be left pinned? if so we insert the memory registration into a memory tree for later lookup, we may also remove a previous registration if a MRU (most recently used) list of registions is full, this prevents resources from being exhausted. 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_mvapi_prepare_src (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Pack data and return a descriptor that can be used for send/put. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL peer addressing
.RE
.PP
prepare source's behavior depends on the following: Has a valid memory registration been passed to prepare_src? if so we attempt to use the pre-registred user-buffer, if the memory registration is to small (only a portion of the user buffer) then we must reregister the user buffer Has the user requested the memory to be left pinned? if so we insert the memory registration into a memory tree for later lookup, we may also remove a previous registration if a MRU (most recently used) list of registions is full, this prevents resources from being exhausted. Is the requested size larger than the btl's max send size? if so and we aren't asked to leave the registration pinned than we register the memory if the users buffer is contiguous Otherwise we choose from two free lists of pre-registered memory in which to pack the data into. 
.SS "int mca_btl_mvapi_put (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * btl_peer, struct \fBmca_btl_base_descriptor_t\fP * decriptor)"
.PP
PML->BTL Initiate a put of the specified size. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIbtl_base_peer\fP (IN) BTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (allocated by PML via mca_btl_base_request_alloc_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting BTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the BTL was able to queue one or more fragments 
.RE
.PP

.SS "int mca_btl_mvapi_register (struct \fBmca_btl_base_module_t\fP * btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void * cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "int mca_btl_mvapi_send (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * btl_peer, struct \fBmca_btl_base_descriptor_t\fP * descriptor, mca_btl_base_tag_t tag)"
.PP
PML->BTL Initiate a send of the specified size. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIbtl_base_peer\fP (IN) BTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (allocated by PML via mca_btl_base_request_alloc_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting BTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the BTL was able to queue one or more fragments 
.RE
.PP

.SS "void mca_btl_mvapi_send_frag_return (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_mvapi_frag_t\fP *)"
.PP
Return a send fragment to the modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIfrag\fP (IN) IB send fragment 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
